#include <Arduino.h>
#include <var.h>
#include <wd.h>
#include <web.h>

#include <DNSServer.h>
#include <ESP8266HTTPClient.h>
#include <ESP8266WiFi.h>
#include <ESPAsyncTCP.h>
#include <ESPAsyncWebServer.h>

AsyncWebServer server(80);
AsyncWebSocket ws("/ws");

const char* ssid = "Luthics' WLAN";
const char* password = "qwerasdf";

void notFound(AsyncWebServerRequest* request) {
    request->send(404, "text/plain", "Not found");
}

String indexhtml =
    "<!DOCTYPE html><html><head><meta charset='UTF-8'><title>高温预警器</title><script>var ws;var "
    "temp=28;window.onload=function(){if('WebSocket'in window){ws=new "
    "WebSocket('ws://'+window.location.host+'/ws"
    "');ws.onopen=function(){document.getElementById('info').innerHTML+='"
    "WebSocket连接成功！<br>';ws.send('connect "
    "ok!')};ws.onmessage=function(evt){document.getElementById('temp')."
    "innerHTML='当前温度：'+evt.data+'℃'};ws.onerror=function(){document."
    "getElementById('info').innerHTML+='通讯发送错误！<br>'};ws.onclose="
    "function(){document.getElementById('info').innerHTML+='"
    "WebSocketTest连接已关闭！<br>'}}else{document.getElementById('info')."
    "innerHTML='浏览器不支持 WebSocket！'}};</script></head><body><h1 "
    "id='temp'>当前温度：27.00℃</h1><form action='temp'method='post'><input "
    "name='temp'id='tempi'/><button "
    "name='submit'value='submit'>设置温度</button></form><div id=' "
    "info'></div></body></html>";

void onEventHandle(AsyncWebSocket* server,
                   AsyncWebSocketClient* client,
                   AwsEventType type,
                   void* arg,
                   uint8_t* data,
                   size_t len) {
    if (type == WS_EVT_CONNECT) {
        Serial.printf("ws[%s][%u] connect\n", server->url(), client->id());
        // client->printf("已成功连接");
        client->ping();
    } else if (type == WS_EVT_DISCONNECT) {
        Serial.printf("ws[%s][%u] disconnect\n", server->url(), client->id());
    } else if (type == WS_EVT_ERROR) {
        Serial.printf("ws[%s][%u] error(%u): %s\n", server->url(), client->id(),
                      *((uint16_t*)arg), (char*)data);
    } else if (type == WS_EVT_PONG) {
        Serial.printf("ws[%s][%u] pong[%u]: %s\n", server->url(), client->id(), len,
                      (len) ? (char*)data : "");
    } else if (type == WS_EVT_DATA) {
        AwsFrameInfo* info = (AwsFrameInfo*)arg;
        Serial.printf("ws[%s][%u] frame[%u] %s[%llu - %llu]:\n", server->url(),
                      client->id(), info->num,
                      (info->message_opcode == WS_TEXT) ? "text" : "binary",
                      info->index, info->index + len);
        data[len] = 0;
        Serial.printf("%s\n", (char*)data);
    }
}

void web_init() {
    Serial.begin(115200);
    WiFi.mode(WIFI_STA);
    WiFi.begin(ssid, password);
    while (WiFi.waitForConnectResult() != WL_CONNECTED) {
        Serial.printf("WiFi Failed!");
        WiFi.begin(ssid, password);
    }

    Serial.print("IP Address:");
    Serial.println(WiFi.localIP());
    sip(WiFi.localIP().toString());

    ws.onEvent(onEventHandle);
    server.addHandler(&ws);

    server.on("/", HTTP_GET, [](AsyncWebServerRequest* request) {
        request->send(200, "text/html", indexhtml);
    });

    server.on("/temp", HTTP_POST, [](AsyncWebServerRequest* request) {
        int tmp;
        if (request->hasParam("temp", true)) {
            tmp = request->getParam("temp", true)->value().toInt();
            stemps(tmp);
            ref_ret(request,
                    "<!DOCTYPE html><html><head><meta http-equiv=\"refresh\" "
                    "content=\"1; "
                    "url='http://192.168.48.159/'\" /></head><body><h1>Success. Back "
                    "after 1 "
                    "sencond.</h1></body></html>");
        } else {
            notFound(request);
        }
    });

    server.onNotFound(notFound);

    server.begin();
}

void web_loop() {
    ws.textAll(String(gtemp()));
    // ws.cleanupClients();
    // sendWechat(getTemp());
}

void ref_ret(AsyncWebServerRequest* request, String html) {
    request->send(200, "text/html", html);
}